﻿using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
namespace StuMgmLib
{
    class Utility
    {
        /// <summary>
        ///  序列化
        /// </summary>
        static byte[] Serialize<T>(T c)
        {
            MemoryStream ms = new MemoryStream();
            BinaryFormatter iFormatter = new BinaryFormatter();
            iFormatter.Serialize(ms, c);
            byte[] buf = ms.GetBuffer();
            return buf;
        }

        /// <summary>
        ///  反序列化
        /// </summary>
        static T Deserialize<T>(byte[] buf)
        {
            MemoryStream ms = new MemoryStream(buf);
            BinaryFormatter iFormatter = new BinaryFormatter();
            T obj = (T)iFormatter.Deserialize(ms);
            return obj;
        }
    }

}


#region QuickTable

internal class QTInfo
{
    public int Token;
    public Lvl Level;
    public QTInfo(int token, Lvl lv)
    {
        Token = token;
        Level = lv;
    }
}
public class QT // quickTable
{
    internal const Int16 tokenMaxCount = 32767;
    internal static Dictionary<short, QTInfo> quickTable = new Dictionary<short, QTInfo>();
}

#endregion